/*
 * Copyright (c) 2013 SEARCH-LAB Ltd.
 * 
 */

#include <gtest/gtest.h>

#include <boost/asio/ip/address.hpp>

#include <cdos/Filter.hpp>

using Ip = boost::asio::ip::address;

class FilterTest : public testing::Test {
protected:
    Ip getIp(const char* ip) const {
        return Ip::from_string(ip);
    }

    Filter<Ip> _filter;
};

TEST_F(FilterTest, addRemoveHas) {
    Ip ip = getIp("192.168.0.1");

    ASSERT_FALSE(_filter.has(ip));

    _filter.add(ip);

    ASSERT_TRUE(_filter.has(ip));

    _filter.remove(ip);

    ASSERT_FALSE(_filter.has(ip));
}
