/*
 * Copyright (c) 2013 SEARCH-LAB Ltd.
 * 
 */

package CounterDoSJ;

import java.net.URL;
import java.util.Hashtable;
import java.util.Scanner;

import org.knopflerfish.service.console.CommandGroup;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class Activator implements BundleActivator {

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext
     * )
     */
    public void start(BundleContext context) throws Exception {
        System.out.println("Launch CDoSJ OSGi bundle");
        
        URL configUrl = context.getBundle().getResource("config/config.json");
        if (configUrl == null) {
            throw new Exception("Failed to get config file");
        }
        
        Scanner scanner = new Scanner(configUrl.openConnection().getInputStream(),"UTF-8");
        String configStr = scanner.useDelimiter("\\A").next();
        scanner.close();
        
        // Start native CDoS Application
        Application.start(configStr);
        
        // Register commands
        {
            CommandGroup command = new CDoSCommandGroup();
            Hashtable props = new Hashtable();
            props.put("groupName", command.getGroupName());
            context.registerService(CommandGroup.class.getName(), command, props);
        }
        
        // Register TunnelFactory
        {
            TunnelFactory tunnelFactory = new TunnelFactory();
            Hashtable props = new Hashtable();
            context.registerService(TunnelFactory.class.getName(), tunnelFactory, props);
        }
        
        System.out.println("CDoSJ OSGi bundle launched");
    }

    /*
     * (non-Javadoc)
     * 
     * @see
     * org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
     */
    public void stop(BundleContext context) throws Exception {
        Application.stop();
        LoadWatcher.haltAll();
    }
}