/*
 * Copyright (c) 2013 SEARCH-LAB Ltd.
 * 
 */

package CounterDoSJ;

public class TunnelMetrics {
    private long totalIncomingRequestCount;
    private long totalOutgoingResponseCount;
    private long totalDroppedFromQueueCount;
    private long currentQueueSize;
    private long totalBlacklistRejection;
    private long totalWhitelistRejection;
    
    public TunnelMetrics(
        long totalIncomingRequestCount,
        long totalOutgoingResponseCount, 
        long totalDroppedFromQueueCount,
        long currentQueueSize, 
        long totalBlacklistRejection,
        long totalWhitelistRejection
    ) {
        super();
        this.totalIncomingRequestCount = totalIncomingRequestCount;
        this.totalOutgoingResponseCount = totalOutgoingResponseCount;
        this.totalDroppedFromQueueCount = totalDroppedFromQueueCount;
        this.currentQueueSize = currentQueueSize;
        this.totalBlacklistRejection = totalBlacklistRejection;
        this.totalWhitelistRejection = totalWhitelistRejection;
    }

    public long getTotalIncomingRequestCount() {
        return totalIncomingRequestCount;
    }

    public long getTotalOutgoingResponseCount() {
        return totalOutgoingResponseCount;
    }

    public long getTotalDroppedFromQueueCount() {
        return totalDroppedFromQueueCount;
    }

    public long getCurrentQueueSize() {
        return currentQueueSize;
    }

    public long getTotalBlacklistRejection() {
        return totalBlacklistRejection;
    }
    
    public long getTotalWhitelistRejection() {
        return totalWhitelistRejection;
    }

    @Override
    public String toString() {
        return String.format(
            "ServiceMetrics [incoming = %s, outgoing = %s, dropped = %s, queue = %s, blacklist reject = %s, whitelist reject = %s]",
            totalIncomingRequestCount, totalOutgoingResponseCount,
            totalDroppedFromQueueCount, currentQueueSize,
            totalBlacklistRejection, totalWhitelistRejection
        );
    }
}
