/*
 * Created on Thu Jul 18 15:05:53 CEST 2013
 */
package CounterDoSJDemo;

import java.net.InetAddress;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import CounterDoSJ.Tunnel;
import CounterDoSJ.TunnelFactory;

/**
 * PoC CDoSJ consumer demo
 */
public class Activator implements BundleActivator {
  
  /** Start handler */
  public void start(BundleContext context) throws Exception {
      System.out.println("Start CDoSJ demo");
      
      // get TunnelFactory
      ServiceReference<TunnelFactory> sr = context.getServiceReference(CounterDoSJ.TunnelFactory.class);
      if (sr != null) {
          TunnelFactory tf = (TunnelFactory) context.getService(sr);
          
          if (tf != null) {
              InetAddress ip = InetAddress.getByName("127.0.0.1");
              _tunnel = tf.createTunnel("apache", ip, 8090, 80);
              _tunnel.start();
          } else {
              System.err.println("Failed to create TunnelFactory");
          }
      } else {
          System.err.println("Failed to get TunnelFactory reference");
      }
  }

  /** Stop handler */
  public void stop(BundleContext context) throws Exception {
      System.out.println("Stop CDoSJ demo");
      
      if (_tunnel != null) {
          _tunnel.stop();
      }
  }
  
  private Tunnel _tunnel;
}