package CounterDoSJTest.network.client;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.SocketTimeoutException;

import CounterDoSJTest.test.Util;

public class UDPClient extends Client {

    public UDPClient(InetAddress clientAddress, InetAddress serverAddress, int serverPort) {
        super(clientAddress, serverAddress, serverPort);
    }

    @Override
    public boolean testEcho() {
        DatagramSocket echoSocket = null;
        try {        
            String message = "hello echo server";
            DatagramPacket packetOut = new DatagramPacket(
                message.getBytes(), 
                message.getBytes().length, 
                _serverAddress, 
                _serverPort
            );
            
            Util.log("testEcho writes socket");
            echoSocket = new DatagramSocket(new InetSocketAddress(_clientAddress, 0));
            echoSocket.setSoTimeout(1000);

            echoSocket.send(packetOut);
            
            Util.log("testEcho reads socket");
            byte[] echoBuffer = new byte[message.length()];
            
            DatagramPacket packetIn = new DatagramPacket(
                echoBuffer, 
                echoBuffer.length
            );
            
            echoSocket.receive(packetIn);
            
            String messageEcho = new String(packetIn.getData());
            return Util.expectEquals(message, messageEcho);
            
        } catch (IOException ex) {
            ex.printStackTrace();
            
            return false;
        } finally {
            echoSocket.close();
        }
    }

    @Override
    public boolean testSilence() {
        DatagramSocket echoSocket = null;
        try {        
            String message = "hello echo server, I may expect no answer I guess.";
            DatagramPacket packetOut = new DatagramPacket(
                message.getBytes(), 
                message.getBytes().length, 
                _serverAddress, 
                _serverPort
            );
            
            Util.log("testSilence writes socket");
            echoSocket = new DatagramSocket(new InetSocketAddress(_clientAddress, 0));
            echoSocket.setSoTimeout(1000);
            
            echoSocket.send(packetOut);
            
            Util.log("testSilence reads socket");
            byte[] echoBuffer = new byte[message.length()];
            
            DatagramPacket packetIn = new DatagramPacket(
                echoBuffer, 
                echoBuffer.length
            );
            
            echoSocket.receive(packetIn);
            
            // silence was expected
            return false;
            
        } catch (SocketTimeoutException ex) {
            // expected timeout
            return true;
        } catch (IOException ex) {
            ex.printStackTrace();
            
            return false;
        } finally {
            echoSocket.close();
        }
    }
}
