package CounterDoSJTest.test;

import CounterDoSJ.Tunnel;
import CounterDoSJ.TunnelFactory;
import CounterDoSJ.Tunnel.FILTER;
import CounterDoSJTest.network.client.Client;

public class BlacklistTest implements Test {

    public BlacklistTest(Client clientA, Client clientB, Tunnel tunnel, TunnelFactory tunnelFactory) {
        _clientA = clientA;
        _clientB = clientB;
        _tunnel = tunnel;
        _tunnelFactory = tunnelFactory;
    }

    @Override
    public boolean run() {
        _tunnel.changeFiltering(FILTER.BLACKLIST);
        
        _status = true;
        
        check(_clientA.testEcho());
        check(_clientB.testEcho());

        _tunnelFactory.blacklistIp(_clientA.getIp());

        check(_clientA.testSilence());
        check(_clientB.testEcho());

        _tunnelFactory.blacklistIp(_clientB.getIp());

        check(_clientA.testSilence());
        check(_clientB.testSilence());

        _tunnelFactory.unblacklistIp(_clientA.getIp());

        check(_clientA.testEcho());
        check(_clientB.testSilence());

        _tunnelFactory.unblacklistIp(_clientB.getIp());

        check(_clientA.testEcho());
        check(_clientB.testEcho());
        
        return _status;
    }
    
    private void check(boolean status) {
        if (!status) {
            Util.log("Check failed:");
            Thread.dumpStack();
        }
        
        _status &= status;
    }

    private boolean _status;
    private Client _clientA;
    private Client _clientB;
    private Tunnel _tunnel;
    private TunnelFactory _tunnelFactory;
}
