package CounterDoSJTest.test;

import CounterDoSJ.Tunnel;
import CounterDoSJ.TunnelFactory;
import CounterDoSJ.Tunnel.FILTER;
import CounterDoSJTest.network.client.Client;

public class WhitelistTest implements Test {

    public WhitelistTest(Client clientA, Client clientB, Tunnel tunnel, TunnelFactory tunnelFactory) {
        _clientA = clientA;
        _clientB = clientB;
        _tunnel = tunnel;
        _tunnelFactory = tunnelFactory;
    }

    @Override
    public boolean run() {
        _tunnel.changeFiltering(FILTER.WHITELIST);
        
        _status = true;
        
        check(_clientA.testSilence());
        check(_clientB.testSilence());
        
        _tunnelFactory.whitelistIp(_clientA.getIp());
        
        check(_clientA.testEcho());
        check(_clientB.testSilence());
        
        _tunnelFactory.whitelistIp(_clientB.getIp());
        
        check(_clientA.testEcho());
        check(_clientB.testEcho());
        
        _tunnelFactory.unwhitelistIp(_clientA.getIp());
        
        check(_clientA.testSilence());
        check(_clientB.testEcho());
        
        _tunnelFactory.unwhitelistIp(_clientB.getIp());
        
        check(_clientA.testSilence());
        check(_clientB.testSilence());
        
        return _status;
    }
    
    private void check(boolean status) {
        if (!status) {
            Util.log("Check failed:");
            Thread.dumpStack();
        }
        
        _status &= status;
    }

    private boolean _status;
    private Client _clientA;
    private Client _clientB;
    private Tunnel _tunnel;
    private TunnelFactory _tunnelFactory;
}
